package	jp.co.sds_corp.tool.apache;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;
import java.net.InetAddress;
import java.net.URLDecoder;

public class LogAnalyzer
{
	String	file;
	String	enc;

	public LogAnalyzer( String file ) {
		this.file = file;
		enc = System.getProperty( "LogAnalyzer.Encode" );
		if ( enc == null ) {
			enc = "JISAutoDetect";
		}
	}

	private class LineInfo
	{
		String	ip;
		String	arg2;
		String	arg3;
		String	time;
		String	request;
		String	response;
		String	size;
		String	referer;
		String	agent;

		String host;
	}

	protected LineInfo parseLine( String line ) throws Exception {
		LineInfo ret = new LineInfo();
		int		nPre, nPos;

		nPre = 0;
		nPos = line.indexOf( " ", nPre );
		ret.ip = line.substring( nPre, nPos );
		InetAddress ad = InetAddress.getByName( ret.ip );
		ret.host = ad.getHostName();
		nPre = nPos + 1;

		nPos = line.indexOf( " ", nPre );
		ret.arg2 = line.substring( nPre, nPos );
		nPre = nPos + 1;

		nPos = line.indexOf( " ", nPre );
		ret.arg3 = line.substring( nPre, nPos );
		nPre = nPos + 1;

		nPos = line.indexOf( "]", nPre );
		ret.time = line.substring( nPre + 1, nPos );
		nPre = nPos + 2;

		nPos = line.indexOf( "\"", nPre + 1 );
		ret.request = line.substring( nPre + 1, nPos );
		nPre = nPos + 2;

		nPos = line.indexOf( " ", nPre );
		ret.response = line.substring( nPre, nPos );
		nPre = nPos + 1;

		nPos = line.indexOf( " ", nPre );
		ret.size = line.substring( nPre, nPos );
		nPre = nPos + 1;

		nPos = line.indexOf( "\"", nPre + 1 );
		ret.referer = URLDecoder.decode(
							line.substring( nPre + 1, nPos ), enc );
		nPre = nPos + 2;

		nPos = line.indexOf( "\"", nPre + 1 );
		ret.agent = line.substring( nPre + 1, nPos );
		nPre = nPos + 2;

		return ret;
	}

	protected void encode( String buf ) {
	}

	public void parse( PrintStream out ) throws Exception {
		BufferedReader rd = new BufferedReader( new FileReader( file ));
		for ( ;; ) {
			String line = rd.readLine();
			if ( line == null ) {
				break;
			}
			LineInfo inf = null;
			try {
				inf = parseLine( line );
			} catch ( Exception e ) {
				System.err.println( "parse error [" + line + "]" );
				continue;
			}
/*
			out.println( inf.ip + ":" + inf.arg2 + ":" + inf.arg3 + ":"
				+ inf.time + ":"
				+ inf.request + ":" + inf.response + ":" + inf.size
				+ ":" + inf.referer + ":" + inf.agent + ":" );
*/
			if ( inf.referer.equals( "-" ) ||
				inf.referer.indexOf( "sds-corp.co.jp" ) >= 0 )
			{
				continue;
			}
			out.println( inf.host + ":" + inf.time
				+ ":" + inf.request + ":" + inf.referer );
		}
		rd.close();
	}

	public static void main( String[] args ) {
		try {
			for ( int i = 0; i < args.length; i++ ) {
				LogAnalyzer obj = new LogAnalyzer( args[i] );
				obj.parse( System.out );
			}
		} catch ( Exception e ) {
			e.printStackTrace();
		}
	}
}

