package jp.co.sds_corp.tool.shell;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import jp.co.sds_corp.test.BasicTestCase;

import com.jcoverage.coverage.Instrumentation;

public class ShellReportTest extends BasicTestCase
{
	public void printCoverage(String filename) throws Exception {
		ObjectInputStream is = new ObjectInputStream(
			new FileInputStream(filename));
		Object obj = is.readObject();
		is.close();
		System.out.println(obj.getClass());

		Map<?,?> map = (Map<?,?> )obj;
		Iterator itr = map.keySet().iterator();
		while (itr.hasNext()) {
			String key = (String )itr.next();
			Object value = map.get(key);

			System.out.println(key + "=" + value);

			Instrumentation inst = (Instrumentation )value;
			printCoverage(inst);
		}
	}

	public void printCoverage(Instrumentation inst) throws Exception {
		System.out.println(inst.getCoverage());
		System.out.println(inst.getSourceLineNumbers());
	}

	void outputCoverage(Map<String,Instrumentation> map) throws Exception {
		ObjectOutputStream os = new ObjectOutputStream(
				new FileOutputStream("jcoverage.ser"));
			os.writeObject(map);
			os.flush();
			os.close();
	}

	void createReport(Map<String,Instrumentation> map) throws Exception {
		File sourceDir = null; //new File(".");
		File reportDir = new File("./target/report");
		ShellReportDriver driver = new ShellReportDriver(sourceDir);

		Set<Map.Entry<String, Instrumentation>> entrySet = map.entrySet();
		for (Map.Entry<String, Instrumentation> entry : entrySet) {
			String shell = entry.getKey();
			Instrumentation inst = entry.getValue();
			driver.addInstrumentation(shell, inst);
		}
		driver.generate(reportDir);
	}

	public void testStart1() throws Exception {
//		printCoverage("jcoverage.ser.sample");

		File result = new File("jcoverage.ser");
		if (result.exists()) {
			result.delete();
		}

/*
		String[] shells = {
			"target/test-classes/test.sh",
			"target/test-classes/target.sh",
		};

		Map<String,Instrumentation> map = new HashMap<String,Instrumentation>();
		for (String shell : shells) {
			ShellInstrumentBuilder builder = new ShellInstrumentBuilder(shell);
			Instrumentation inst = builder.getInstrumentation();
			inst.touch(4);
			inst.touch(4);
			inst.touch(5);
			printCoverage(inst);

			map.put(shell, inst);
		}
		createReport(map);
*/

//		outputCoverage(map);
//		printCoverage("jcoverage.ser");
	}

	public static void main(String[] args) {
		try {
			ShellReportTest obj = new ShellReportTest();
			obj.testStart1();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
